#property link "http://www.argolab.net/"
#property copyright " http://www.argolab.net/"

extern int x0 = 15;
extern int y0 = 15;

int first_time = 0;

int OnInit()  {
   but();
   return(INIT_SUCCEEDED);
}

void OnTick()  {
   but();
}

void OnDeinit(const int reason)  {
   first_time = 0;
   clearChart(prefix);
   Comment(WindowExpertName()+" successfully deinitialized !   "+getUninitReasonText(_UninitReason));
}

string prefix="but";

bool display_status = TRUE;

void but() {
   string name = prefix+"BUT1";

   if (first_time == 0) {
      ButtonCreate(0,name,0,x0,y0+14,90,16,0,"BUTTON","Arial",10,clrBlack,C'236,233,216'); //  
      first_time = 1;
   }

   if (but_stat(name)) {
      display_status = !display_status;
      button_off(name);                                                                   //   
   }

   if (display_status) Show_Box(1);
      else Show_Box(-1);
}

void Show_Box(int key) {
   string oname = prefix + "Box";
   if (key > 0) {
      if (ObjectFind(oname) < 0) {
         ObjectCreate(oname, OBJ_LABEL, 0, 0, 0);
         ObjectSetText(oname, "g", 50, "Webdings", DimGray);
         ObjectSet(oname, OBJPROP_XDISTANCE, 10);
         ObjectSet(oname, OBJPROP_YDISTANCE, 75);
         ObjectSet(oname,OBJPROP_CORNER,0);
      }
   } else {
      ObjectDelete(oname);
   }
}

//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
bool but_stat(string name)
  {
   if(ObjectGetInteger(0,name,OBJPROP_STATE)==true)
      return true;
   return false;
  }
//+------------------------------------------------------------------+
//|                            |
//+------------------------------------------------------------------+
bool button_off(string name)  {
   if(ObjectSetInteger(0,name,OBJPROP_STATE,false)==true)
      return true;   return false;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool ButtonCreate(const long              chart_ID=0,// ID 
                  string                  name="Button",//  
                  const int               sub_window=0,//  
                  const int               xx=0,                      //    X
                  const int               yy=0,                      //    Y
                  const int               width=50,                 //  
                  const int               height=18,                //  
                  const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //    
                  const string            text="Button",            // 
                  const string            font="Arial",             // 
                  const int               font_size=10,             //  
                  const color             clr=clrBlack,             //  
                  const color             back_clr=C'236,233,216',  //  
                  const color             border_clr=clrNONE,       //  
                  const bool              state=false,              // /
                  const bool              back=false,               //   
                  const bool              selection=false,          //   
                  const bool              hidden=true,              //    
                  const long              z_order=0,                //    
                  const string            toltip="")
  {
   ResetLastError();
   if(ObjectCreate(chart_ID,name,OBJ_BUTTON,sub_window,0,0))
     {
      ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);     //---  (true)   (false)    
      ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
      ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);

      ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);                //---   
      ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);         //---   
      ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);//---   ,      
     }
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,xx);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,yy);
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);              //---   
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);                 //---  
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);                 //---   
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);       //---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);                //---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);            //---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);           //---         
   ObjectSetString(chart_ID,name,OBJPROP_TOOLTIP,toltip);                 //---     
   return(true);
}

///     
int clearChart(string prefix_) {
	int obj_total = ObjectsTotal();
	string name;
	int count = 0;
	for (int i = obj_total - 1; i >= 0; i--) {
		name = ObjectName(i);
		if (StringFind(name, prefix_) == 0) {
			ObjectDelete(name);
			count++;
		}			
	}
	return(count);
}


//+------------------------------------------------------------------+
//|                  |
//+------------------------------------------------------------------+
string getUninitReasonText(int reasonCode)
  {
   string text="";
   bool Lan=(TerminalInfoString(TERMINAL_LANGUAGE)=="Russian");
   switch(reasonCode)
     {
      case 0:
         if(Lan)
         text="   ,   ExpertRemove()";   break;
         text="Account was changed";                                            break;
      case 1:
         if(Lan)
         text="   ";                              break;
         text="Program "+__FILE__+" was removed from chart";              break;
      case 2:
         if(Lan)
         text=" ";                              break;
         text="Program "+__FILE__+" was recompiled";                      break;
      case 3:
         if(Lan)
         text="     ";                          break;
         text="Symbol or timeframe was changed";                                break;
      case 4:
         if(Lan)
         text=" ";                                                  break;
         text="Chart was closed";                                               break;
      case 5:
         if(Lan)
         text="    ";                  break;
         text="Input-parameter was changed";                                    break;
      case 6:
         if(Lan)
         text="    ";                           break;
         text="Reconnect to the trading server";                                break;
      case 7:
         if(Lan)
         text="   ";                                 break;
         text="New template was applied to chart";                              break;
      case 8:
         if(Lan)
         text=" ,   OnInit()   ";break;
         text="A sign that the handler OnInit() returned non-zero value";       break;
      case 9:
         if(Lan)
         text="  ";                                            break;
         text="The terminal was closed";                                        break;
      default:
         if(Lan)
         text="    ";
         text="Another reason";
     }
   return text;
  }
